Public Class ParsedDate
    Private m_HasError As Boolean = False

    Private m_TextWert As String = ""

    Public Sub New(ByVal Text As String)
        Dim TrimmedText As String = Text.Trim
        m_TextWert = TrimmedText

        If TrimmedText.IndexOf(".") > -1 Then
            Try
                Dim Teile() As String = TrimmedText.Split(".")
                Dim Tag As Integer = CInt(Teile(0))
                Dim Monat As Integer = CInt(Teile(1))
                Dim Jahr As Integer = GetJahr(Teile(2))
                If Tag > 0 AndAlso Tag < 32 AndAlso Monat > 0 AndAlso Monat < 13 AndAlso Jahr > -1 Then
                    Dim Datum As New Date(Jahr, Monat, Tag)
                    m_TextWert = Datum.ToShortDateString
                End If
            Catch ex As Exception
                m_HasError = True
            End Try
        ElseIf TrimmedText.ToLower = "h" Then
            m_TextWert = Date.Today.ToShortDateString
        ElseIf TrimmedText.ToLower = "g" Then
            Dim Datum As Date = Date.Today
            Datum = Datum.AddDays(-1)
            m_TextWert = Datum.ToShortDateString
        ElseIf TrimmedText.ToLower = "m" Then
            Dim Datum As Date = Date.Today
            Datum = Datum.AddDays(1)
            m_TextWert = Datum.ToShortDateString
        ElseIf TrimmedText.ToLower = "v" Then
            Dim Datum As Date = Date.Today
            Datum = Datum.AddDays(-2)
            m_TextWert = Datum.ToShortDateString
        ElseIf TrimmedText.ToLower = "" Then
            Dim Datum As Date = Date.Today
            Datum = Datum.AddDays(2)
            m_TextWert = Datum.ToShortDateString
        ElseIf TrimmedText.StartsWith("+") Then
            Try
                Dim Tage As Integer = CInt(TrimmedText.Substring(1))
                Dim Datum As Date = Date.Today
                Datum = Datum.AddDays(Tage)
                m_TextWert = Datum.ToShortDateString
            Catch ex As Exception
                m_HasError = True
            End Try
        ElseIf TrimmedText.StartsWith("-") Then
            Try
                Dim Tage As Integer = CInt(TrimmedText.Substring(1))
                Dim Datum As Date = Date.Today
                Datum = Datum.AddDays(Tage * -1)
                m_TextWert = Datum.ToShortDateString
            Catch ex As Exception
                m_HasError = True
            End Try
        ElseIf IsNumeric(TrimmedText) Then
            Try
                If TrimmedText.Length > 5 Then
                    Try
                        Dim TagTeil As String = TrimmedText.Substring(0, 2)
                        Dim MonatTeil As String = TrimmedText.Substring(2, 2)
                        Dim JahrTeil As String = TrimmedText.Substring(4)
                        Dim Jahr As Integer = GetJahr(JahrTeil)

                        If Jahr <> -1 Then
                            Dim Datum As New Date(Jahr, MonatTeil, TagTeil)
                            m_TextWert = Datum.ToShortDateString
                        End If
                    Catch ex As Exception
                        m_HasError = True
                    End Try
                Else
                    m_HasError = True
                End If
            Catch ex As Exception
                m_HasError = True
            End Try
        End If
        If Not m_HasError AndAlso m_TextWert <> "" Then
            Try
                Dim Datum As Date = CDate(m_TextWert)
            Catch ex As Exception
                m_HasError = True
            End Try

        End If
    End Sub
    ReadOnly Property HasError() As Boolean
        Get
            Return m_HasError
        End Get
    End Property
    ReadOnly Property Datum() As DateTime
        Get
            If m_HasError Then
                Return DateTime.MinValue
            Else
                If m_TextWert = "" Then
                    Return DateTime.MinValue
                Else
                    Return CDate(m_TextWert)
                End If

            End If
        End Get
    End Property
    ReadOnly Property TextWert() As String
        Get
            Return m_TextWert
        End Get
    End Property

    Private Function GetJahr(ByVal JahrTeil As String) As Integer
        Try
            Dim Jahr As Integer = CInt(JahrTeil.Trim)
            If Jahr > 1850 AndAlso Jahr < 2100 Then
                Return Jahr
            ElseIf Jahr < 100 Then
                Dim VergleichsJahr As Integer = DateTime.Today.Year + 10
                Dim Jahrhundert As Integer = CInt(VergleichsJahr.ToString.Substring(0, 2)) * 100
                Dim AktJahr As Integer = VergleichsJahr - Jahrhundert
                If Jahr > AktJahr Then
                    Return Jahr + Jahrhundert - 100
                Else
                    Return Jahr + Jahrhundert
                End If
            End If
        Catch ex As Exception

        End Try
        Return -1
    End Function
End Class
