Imports System.Xml
Public Class DataProvider
    Private Shared m_Befunde As BefundTextEintragsListe
    Private Shared m_Diagnosen As TextEintragsListe
    Private Shared m_FonFax As FonFaxListe
    Shared ReadOnly Property Befunde() As BefundTextEintragsListe
        Get
            Return m_Befunde
        End Get
    End Property
    Shared ReadOnly Property Diagnosen() As TextEintragsListe
        Get
            Return m_Diagnosen
        End Get
    End Property
    Shared ReadOnly Property FonFax() As FonFaxListe
        Get
            Return m_FonFax
        End Get
    End Property
    Shared Sub New()
        If IO.File.Exists(Application.StartupPath & "\TestDaten.xml") Then
            Dim BaseNd As XmlNode = GetXML(Application.StartupPath & "\TestDaten.xml")
            For Each Nd As XmlNode In BaseNd.ChildNodes
                If Nd.Name = "Befunde" Then
                    m_Befunde = New BefundTextEintragsListe(Nd)
                    Exit For
                End If
            Next
            For Each Nd As XmlNode In BaseNd.ChildNodes
                If Nd.Name = "Diagnosen" Then
                    m_Diagnosen = New TextEintragsListe(Nd)
                    Exit For
                End If
            Next
            For Each Nd As XmlNode In BaseNd.ChildNodes
                If Nd.Name = "FonFax" Then
                    m_FonFax = New FonFaxListe(Nd)
                    Exit For
                End If
            Next
        End If
        If m_Befunde Is Nothing Then
            m_Befunde = New BefundTextEintragsListe
        End If
        If m_Diagnosen Is Nothing Then
            m_Diagnosen = New TextEintragsListe
        End If
        If m_FonFax Is Nothing Then
            m_FonFax = New FonFaxListe
        End If
    End Sub
    Shared Sub Speichern()
        Dim Writer As XmlTextWriter = GetWriter(Application.StartupPath & "\TestDaten.xml")

        Writer.WriteStartElement("Befunde")
        m_Befunde.Write_XML(Writer)
        Writer.WriteEndElement()
        Writer.WriteStartElement("Diagnosen")
        m_Diagnosen.Write_XML(Writer)
        Writer.WriteEndElement()
        Writer.WriteStartElement("FonFax")
        m_FonFax.Write_XML(Writer)
        Writer.WriteEndElement()

        CloseWriter(Writer)
    End Sub
    Shared Function GetWriter(ByVal Pfad As String) As XmlTextWriter
        Dim Writer As New XmlTextWriter(Pfad, System.Text.Encoding.UTF8)
        Writer.WriteStartDocument(True)

        Writer.WriteStartElement("Elemente")
        Writer.WriteStartElement("Content")
        Return Writer
    End Function
    Shared Sub CloseWriter(ByVal Writer As XmlTextWriter)
        Writer.WriteEndElement()
        Writer.WriteEndElement()
        Writer.WriteEndDocument()
        Writer.Close()
    End Sub


    Shared Function GetXML(ByVal Pfad As String) As XmlNode
        Dim reader As XmlTextReader = New XmlTextReader(Pfad)

        reader.WhitespaceHandling = WhitespaceHandling.None
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(reader)
        reader.Close()

        Dim xnod As XmlNode = xmlDoc.DocumentElement

        Return xnod.ChildNodes(0)
    End Function
End Class
