Imports System.Xml
Public Class BefundTextEintrag
    Inherits ChangeListItem

    Private m_Wichtig As Boolean = False
    Private m_Text As String = ""
    Private m_Kategorie As String = ""
    Private m_Printed As Boolean = True
    Private m_Datum As Date = Date.MinValue

    Private m_Parent As BefundTextEintragsListe
    Public Sub New(ByVal Parent As BefundTextEintragsListe)
        m_Parent = Parent
    End Sub
    Public Sub New(ByVal Parent As BefundTextEintragsListe, ByVal Nd As XmlNode)
        m_Parent = Parent
        m_Wichtig = CBool(Nd.Attributes("wichtig").Value)
        m_Datum = CDate(Nd.Attributes("Datum").Value)
        m_Text = Nd.Attributes("Text").Value
        m_Kategorie = Nd.Attributes("Kategorie").Value
        m_Printed = CBool(Nd.Attributes("Printed").Value)
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Datum", m_Datum.ToString)
        Writer.WriteAttributeString("wichtig", m_Wichtig.ToString)
        Writer.WriteAttributeString("Text", m_Text)
        Writer.WriteAttributeString("Kategorie", m_Kategorie)
        Writer.WriteAttributeString("Printed", m_Printed.ToString)
    End Sub
    Property Wichtig() As Boolean
        Get
            Return m_Wichtig
        End Get
        Set(ByVal value As Boolean)
            If m_Wichtig <> value Then
                m_Wichtig = value
                m_Parent.RaiseChanged("Wichtig")
                m_Printed = False
            End If
        End Set
    End Property
    Property Text() As String
        Get
            Return m_Text
        End Get
        Set(ByVal value As String)
            If m_Text <> value.Trim Then
                m_Text = value.Trim
                m_Printed = False
            End If
        End Set
    End Property
    Property Kategorie() As String
        Get
            Return m_Kategorie
        End Get
        Set(ByVal value As String)
            If m_Kategorie <> value.Trim Then
                m_Kategorie = value.Trim
                m_Printed = False
            End If
        End Set
    End Property

    Property Datum() As Date
        Get
            Return m_Datum
        End Get
        Set(ByVal value As Date)
            If m_Datum <> value Then
                m_Datum = value
                m_Printed = False
            End If
        End Set
    End Property

    Property Printed() As Boolean
        Get
            Return m_Printed
        End Get
        Set(ByVal value As Boolean)
            m_Printed = value
        End Set
    End Property
    Public Sub ValidateText()
        m_Parent.RaiseChanged("Text")
        m_Parent.ValidateForNewItem()
    End Sub
    Public Sub ValidateKategorie()
        m_Parent.RaiseChanged("Kategorie")
        m_Parent.ValidateForNewItem()
    End Sub
    Public Sub ValidateDatum()
        m_Parent.RaiseChanged("Datum")
    End Sub

    Public Overrides Function IsEmpty() As Boolean
        If m_Text = "" AndAlso m_Kategorie = "" Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Overrides Function CreateControl(ByVal Editor As EintragsEditor) As IEditorControlItem
        Return New BefundEditorItem(Editor, Me)
    End Function
    Public Function CreateLabel(ByVal ShowDate As Boolean) As String
        Dim DatString As String = ""
        Dim MinDate As New Date(1860, 1, 1)
        If ShowDate AndAlso m_Datum > MinDate Then
            DatString = " " & Format(m_Datum, "dd.MM")
        End If

        Return m_Kategorie & DatString
    End Function
   
End Class
