Imports System.Xml
Public Class BefundTextEintragsListe
    Inherits TempItemList(Of BefundTextEintrag)

    Public Overrides Function CreateNewItem() As ChangeListItem
        Return New BefundTextEintrag(Me)
    End Function
    Public Sub New()
        Me.Add(New BefundTextEintrag(Me))
    End Sub
    Public Sub New(ByVal xNd As XmlNode)
        For Each Nd As XmlNode In xNd.ChildNodes
            If Nd.Name = "Eintrag" Then
                Me.Add(New BefundTextEintrag(Me, Nd))
            End If
        Next
        Me.Add(New BefundTextEintrag(Me))
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        For Each DE As BefundTextEintrag In Me
            If Not DE.IsEmpty Then
                Writer.WriteStartElement("Eintrag")
                DE.Write_XML(Writer)
                Writer.WriteEndElement()
            End If
        Next
    End Sub

    Public Overrides Sub SortList()
        Dim LastItem As BefundTextEintrag = Me.Item(Me.Count - 1)
        Me.RemoveAt(Me.Count - 1)
        Me.Sort(New BefundTextEintragComparer)
        Me.Add(LastItem)
        Me.RaiseChanged("")
    End Sub

    Public Overrides Function CanSort() As Boolean
        Return True
    End Function

    Public Overrides Function GetColorStrings() As System.Collections.Generic.List(Of ColorString)
        Dim Result As New List(Of ColorString)
        Dim MinDatum As New Date(1860, 1, 1)
        For Each Rw As BefundTextEintrag In Me
            If Not Rw.IsEmpty Then
                Dim DatStr As String = ""
                If Rw.Datum < MinDatum Then
                    DatStr = ""
                Else
                    DatStr = " " & Format(Rw.Datum, "d.M.")
                End If
                If Rw.Wichtig Then
                    Result.Add(New ColorString(Chr(183), ColorLib.WarningColor))
                    Result.Add(New ColorString(Rw.Kategorie & DatStr, ColorLib.ZimmerColor))
                    Result.Add(New ColorString(Rw.Text, ColorLib.WarningColor))
                Else
                    Result.Add(New ColorString(Chr(183)))
                    Result.Add(New ColorString(Rw.Kategorie & DatStr, ColorLib.ZimmerColor))
                    Result.Add(New ColorString(Rw.Text))
                End If
            End If
        Next

        Return Result
    End Function

    Public Overrides Function HeaderControl() As System.Windows.Forms.Control
        Return New BefundHeader
    End Function
End Class
