Imports System.Xml
Public Class FonFax
    Inherits ChangeListItem

    Private m_Bezeichnung As String = ""
    Private m_Nummer As String = ""
    Private m_Parent As FonFaxListe
    Public Sub New(ByVal Parent As FonFaxListe)
        m_Parent = Parent
        m_Bezeichnung = "Telefon"
    End Sub

    Public Sub New(ByVal Parent As FonFaxListe, ByVal Nd As XmlNode)
        m_Parent = Parent
        m_Bezeichnung = Nd.Attributes("Bezeichnung").Value
        m_Nummer = Nd.Attributes("Nummer").Value
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Bezeichnung", m_Bezeichnung)
        Writer.WriteAttributeString("Nummer", m_Nummer)
    End Sub


    Property Bezeichnung() As String
        Get
            Return m_Bezeichnung
        End Get
        Set(ByVal value As String)
            If m_Bezeichnung <> value.Trim Then
                m_Bezeichnung = value.Trim
                m_Parent.RaiseChanged("Bezeichnung")
            End If
        End Set
    End Property
    Property Nummer() As String
        Get
            Return m_Nummer
        End Get
        Set(ByVal value As String)
            If m_Nummer <> value.Trim Then
                m_Nummer = value.Trim
                m_Parent.RaiseChanged("Nummer")
            End If
        End Set
    End Property
    Public Sub ValidateForNewItem()
        m_Parent.ValidateForNewItem()
    End Sub

    Public Overrides Function CreateControl(ByVal Editor As EintragsEditor) As IEditorControlItem
        Return New FonFaxEditorItem(Editor, Me)
    End Function

    Public Overrides Function IsEmpty() As Boolean
        If m_Bezeichnung = "" OrElse m_Nummer = "" Then
            Return True
        Else
            Return False
        End If
    End Function
End Class

