Public Class FonFaxEditorItem
    Implements IEditorControlItem

    Public Event ShouldBeDeleted(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.ShouldBeDeleted
    Public Event WasSelected(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.WasSelected

    Private m_Source As FonFax
    Private m_Initializing As Boolean = False


    Public ReadOnly Property Source() As ChangeListItem Implements IEditorControlItem.Source
        Get
            Return m_Source
        End Get
    End Property

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        Dim Rect As Rectangle = New Rectangle(-1, -1, Me.Width, Me.Height)
        ControlPaint.DrawVisualStyleBorder(e.Graphics, Rect)
    End Sub

    Private Sub TextEintragEditorItem_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Enter
        RaiseEvent WasSelected(Me)
    End Sub

    Private Sub Button1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Button1.KeyUp
        If e.KeyCode = Keys.Delete Then
            RaiseEvent ShouldBeDeleted(Me)
        End If
    End Sub

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

    End Sub
    Public Sub New(ByVal Parent As EintragsEditor, ByVal Source As FonFax)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Source = Source
        Read_Source()
    End Sub
    Private Sub Read_Source()
        m_Initializing = True
        Me.ComboBoxBezeichnung.Text = m_Source.Bezeichnung
        Me.TextBoxNummer.Text = m_Source.Nummer
        m_Initializing = False
    End Sub

    Public WriteOnly Property AutoCompleteStringCollection() As System.Windows.Forms.AutoCompleteStringCollection Implements IEditorControlItem.AutoCompleteStringCollection
        Set(ByVal value As System.Windows.Forms.AutoCompleteStringCollection)

        End Set
    End Property

    Private Sub ComboBoxBezeichnung_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBoxBezeichnung.GotFocus
        ComboBoxBezeichnung.SelectionStart = ComboBoxBezeichnung.Text.Length
        ComboBoxBezeichnung.SelectionLength = 0
    End Sub

    Private Sub ComboBoxBezeichnung_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBoxBezeichnung.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Bezeichnung = ComboBoxBezeichnung.Text
    End Sub

    Private Sub TextBoxNummer_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxNummer.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Nummer = TextBoxNummer.Text
    End Sub

    Private Sub FonFaxEditorItem_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LostFocus
        Me.ComboBoxBezeichnung.SelectedText = ""
    End Sub

    Private Sub FonFaxEditorItem_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Dim RestWidth As Integer = Me.Width - 22
        Dim HalfWidth As Integer = (Me.Width - 22) \ 2 + 1
        Me.ComboBoxBezeichnung.Width = HalfWidth
        Me.TextBoxNummer.Left = Me.ComboBoxBezeichnung.Left + Me.ComboBoxBezeichnung.Width - 1
        Me.TextBoxNummer.Width = Me.Width - Me.TextBoxNummer.Left + 2
        ComboBoxBezeichnung.SelectionLength = 0

    End Sub

    Private Sub ComboBoxBezeichnung_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ComboBoxBezeichnung.Validating
        m_Source.ValidateForNewItem()
    End Sub

    Private Sub TextBoxNummer_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxNummer.Validating
        m_Source.ValidateForNewItem()
    End Sub
End Class
