Public Class TextEintragEditorItem
    Implements IEditorControlItem

    Public Event ShouldBeDeleted(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.ShouldBeDeleted
    Public Event WasSelected(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.WasSelected

    Private m_Source As TextEintrag
    Private m_Initializing As Boolean = False

    Private Shared VBar As New VScrollBar

    Private Sub RefreshTextBoxSize()
        If Me.TextBoxDetails.Text <> "" Then
            Dim TextMeasureWidth As Single = Me.TextBoxDetails.Width - VBar.Width
            Dim g As Graphics = Me.CreateGraphics
            Dim sf As New StringFormat(StringFormat.GenericDefault)
            sf.FormatFlags = sf.FormatFlags Or StringFormatFlags.MeasureTrailingSpaces Or StringFormatFlags.FitBlackBox

            Dim Height As Single = g.MeasureString(TextBoxDetails.Text, TextBoxDetails.Font, New SizeF(TextMeasureWidth, 20000.0F), sf).Height
            Height = Math.Round(Height + 3.0F)
            Dim MaxHeight As Integer = Math.Max(38, CInt(Height))
            Me.Height = MaxHeight
            Me.TextBoxDetails.Height = MaxHeight + 1
            Me.Button1.Height = MaxHeight + 3
        Else
            Me.Height = 38
            Me.TextBoxDetails.Height = 39
            Me.Button1.Height = 41
        End If
    End Sub
    Public ReadOnly Property Source() As ChangeListItem Implements IEditorControlItem.Source
        Get
            Return m_Source
        End Get
    End Property


    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        Dim Rect As Rectangle = New Rectangle(-1, -1, Me.Width, Me.Height)
        ControlPaint.DrawVisualStyleBorder(e.Graphics, Rect)
    End Sub

    Private Sub TextEintragEditorItem_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Enter
        RaiseEvent WasSelected(Me)
    End Sub

    Private Sub Button1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Button1.KeyUp
        If e.KeyCode = Keys.Delete Then
            RaiseEvent ShouldBeDeleted(Me)
        End If
    End Sub

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

    End Sub
    Public Sub New(ByVal Parent As EintragsEditor, ByVal Source As TextEintrag)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Source = Source
        Read_Source()
    End Sub
    Private Sub Read_Source()
        m_Initializing = True
        Me.TextBoxDetails.Text = m_Source.Text
        Me.CheckBoxWichtig.Checked = m_Source.Wichtig
        If m_Source.Wichtig Then
            Me.TextBoxDetails.ForeColor = Color.Red
        Else
            Me.TextBoxDetails.ForeColor = Color.Black
        End If
        RefreshTextBoxSize()
        m_Initializing = False
    End Sub

    Private Sub CheckBoxWichtig_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxWichtig.CheckedChanged
        If m_Initializing Then Exit Sub
        m_Source.Wichtig = CheckBoxWichtig.Checked
        If m_Source.Wichtig Then
            Me.TextBoxDetails.ForeColor = Color.Red
        Else
            Me.TextBoxDetails.ForeColor = Color.Black
        End If
    End Sub

    Private Sub TextBoxDetails_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxDetails.Resize
        RefreshTextBoxSize()
    End Sub

    Private Sub TextBoxDetails_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxDetails.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Text = TextBoxDetails.Text
    End Sub

    Private Sub TextBoxDetails_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxDetails.Validating
        If m_Initializing Then Exit Sub
        Dim ZText As String = TextBoxDetails.Text.Replace(Chr(13), " ")
        ZText = ZText.Replace(Chr(13), " ")
        ZText = ZText.Replace(Chr(10), " ")

        While ZText.IndexOf("  ") > -1
            ZText = ZText.Replace("  ", " ")
        End While
        TextBoxDetails.Text = ZText.Trim

        m_Source.ValidateText()
        RefreshTextBoxSize()
    End Sub

    Public WriteOnly Property AutoCompleteStringCollection() As System.Windows.Forms.AutoCompleteStringCollection Implements IEditorControlItem.AutoCompleteStringCollection
        Set(ByVal value As System.Windows.Forms.AutoCompleteStringCollection)

        End Set
    End Property
End Class
